local L,SN,ST = DXE.L,DXE.SN,DXE.ST

------------------------
-- Alysrazor
------------------------
do
	local data = {
		version = 2,
		key = "Alysrazor",
		zone = L.zone["Firelands"],
		category = L.zone["Firelands"],
		name = L.npc_firelands["Alysrazor"],
		triggers = {
			scan = {
				52530, -- Alysrazor
				54015, -- Staghelm (to trigger first encounter)
			},
			yell = L.chat_firelands["^I serve a new master now"],
		},
		onactivate = {
			tracing = {52530}, -- Alysrazor
			tracerstart = true,
			combatstop = true,
			defeat = 52530,
		},
		userdata = {
			imprintedtext = "",
			phase = 0,
		},
		onstart = {
			{
				"set",{phase = 1},
				"alert","phasedur",
				"alert","phasewarn",
			},
			{
				"expect",{"&difficulty&",">=","3"}, --10h&25h
				"alert","firestormcd",
			},
		},
		windows = {
		},
		timers = {
		},
		alerts = {
			phasedur = {
				varname = format(L.alert["Phase Duration"]),
				type = "dropdown",
				text = format(L.alert["Phase %s Duration"],"<phase>"),
				time = 189,
				time2 = 166,
				flashtime = 10,
				color1 = "BLUE",
			},
			phasewarn = {
				varname = format(L.alert["Phase Warning"]),
				type = "simple",
				text = format(L.alert["Phase %s Warning"],"<phase>"),
				time = 3,
				color1 = "BLUE",
				sound = "ALERT1",
			},
			firestormcd = {
				varname = format(L.alert["%s Cooldown"],SN[100744]),
				type = "centerpopup",
				text = format(L.alert["%s Cooldown"],SN[100744]),
				time = 30, --???
				flashtime = 5,
				color1 = "YELLOW",
				icon = ST[100744],
			},
			firestormwarn = {
				varname = format(L.alert["%s Casting"],SN[100744]),
				type = "centerpopup",
				text = format(L.alert["%s Casting"],SN[100744]),
				time = 5,
				flashtime = 5,
				color1 = "YELLOW",
				color2 ="RED",
				icon = ST[100744],
				sound = "ALERT12",
			},
			fieroblastwarn = {
				varname = format(L.alert["%s Casting"],SN[101223]),
				type = "centerpopup",
				text = format(L.alert["%s Casting"],SN[101223]),
				time = 3,
				flashtime = 3,
				color1 = "ORANGE",
				icon = ST[101223],
				sound = "ALERT2",
			},
			imprinted = {
				varname = format(L.alert["%s Warning"],SN[100360]),
				type = "simple",
				text = format(L.alert["%s on %s"],SN[100360],"<imprintedtext>"),
				time = 3,
				flashtime = 3,
				color1 = "GREY",
				icon = ST[100360],
				sound = "ALERT3",
			},
			tantrumcd = {
				varname = format(L.alert["%s Cooldown"],SN[100852]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[100852]),
				time = 15,
				flashtime = 5,
				color1 = "ORANGE",
				icon = ST[100852],
				throttle = 2, --possbily
			},
			vortexinc = {
				varname = format(L.alert["%s Incoming"],SN[99794]),
				type = "centerpopup",
				text = format(L.alert["%s Incoming"],SN[99794]),
				time = 10,
				flashtime = 5,
				icon = ST[99794],
				color1 = "ORANGE",
			},
			vortexdur = {
				varname = format(L.alert["%s Duration"],SN[99794]),
				type = "centerpopup",
				text = format(L.alert["%s Duration"],SN[99794]),
				time = 22,
				flashtime = 5,
				icon = ST[99794],
				color1 = "ORANGE",
			},
			igniteddur = {
				varname = format(L.alert["%s Duration"],SN[99922]),
				type = "dropdown",
				text = format(L.alert["%s Duration"],SN[99922]),
				time = 19,
				flashtime = 5,
				color1 = "YELLOW",
				icon = ST[99922],
			},
			wingsself = {
				varname = format(L.alert["%s Duration"],SN[98619]),
				type = "dropdown",
				text = format(L.alert["%s Duration"],SN[98619]),
				time = 15,
				time2 = 20,
				flashtime = 5,
				color1 = "CYAN",
				icon = ST[98619],
			},
			eggscd = {
				varname = format(SN[100363]),
				type = "centerpopup",
				text = format(SN[100363]),
				time = 6,
				flashtime = 6,
				color1 = "TAN",
				icon = ST[98725],
				sound = "AlERT7",
			},
			-- heroic
			firestormcd = {
				varname = format(L.alert["%s Cooldown"],SN[100744]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[100744]),
				time = 30, --???
				flashtime = 5,
				color1 = "YELLOW",
				icon = ST[100744],
			},
			meteorwarn = {
				varname = format(L.alert["%s Casting"],SN[100761]),
				type = "centerpopup",
				text = format(L.alert["%s Casting"],SN[100761]),
				time = 5,
				flashtime = 5,
				color1 = "GREEN",
				icon = ST[100761],
				sound = "ALERT8",
			},
		},
		announces = {
		},
		raidicons = {
		},
		events = {
			-- Phase 1
			-- Wings of Flame (self only)
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APLLIED",
				spellname= 98619,
				execute = {
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert",{"wingsself",time=2},
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REFRESH",
				spellname= 98619,
				execute = {
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert",{"wingsself"},
					},
				},
			},
			-- Fieroblast
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellname= 101223,
				execute = {
					{
						"alert","fieroblastwarn",
					},
				},
			},
			-- Hatchling
			-- Imprinted
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APLLIED",
				spellname= 100360,
				execute = {
					{
						"set",{imprintedtext = "#5#"},
						"alert","imprinted",
					},
				},
			},
			-- Satiated
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APLLIED",
				spellname= 100852,
				execute = {
					{
						"alert","tantrumcd",
					},
				},
			},
			-- Herald (heroic)
			-- Cataclysm
			-- Firestorm heroic only
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid= 100744,
				execute = {
					{
						"alert","firestormwarn",
						"alert","firestormcd",
					},
				},
			},
			-- Meteor heroic only
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellid= 100761,
				srcisnpctype = true,
				execute = {
					{
						"alert","meteorwarn",
					},
				},
			},
			-- Phase 3
			-- Ignited
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellname= 99922,
				execute = {
					{
						"alert","igniteddur",
					},
				},
			},
			-- Yells
			{
				type = "event",
				event = "YELL",
				execute = {
					-- Phase 1
					{
						"expect",{"#1#","find",L.chat_firelands["^I will burn you from the skies"]},
						"set",{phase = 1},
						"alert","phasewarn",
						"alert",{"phasedur",time = 2},
					},
					-- Phase 2
					{
						"expect",{"#1#","find",L.chat_firelands["^These skies are MINE!"]},
						"alert","vortexinc",
						"schedulealert",{"vortexdur",10},
						"set",{phase = 2},
						"alert","phasewarn",
					},
					-- Phase 3
					{
						"expect",{"#1#","find",L.chat_firelands["^Fire..."]},
						"set",{phase = 3},
						"alert","phasewarn",
					},
				},
			},
			-- Emotes
			{
				type = "event",
				event = "EMOTE",
				execute = {
					-- Eggs
					{
						"expect",{"#1#","find",L.chat_firelands["^The Molten Eggs begin to hatch"]},
						"alert","eggscd",
					},
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end

------------------------
-- Baleroc
------------------------
do
	local data = {
		version = 2,
		key = "Baleroc",
		zone = L.zone["Firelands"],
		category = L.zone["Firelands"],
		name = L.npc_firelands["Baleroc"],
		triggers = {
			scan = {
				53494, -- Baleroc
			},
		},
		onactivate = {
			tracing = {53494}, -- Baleroc
			tracerstart = true,
			combatstop = true,
			defeat = 53494,
		},
		userdata = {
			blazetext = "",
			countdownunits = {type = "container", wipein = 3},
		},
		onstart = {
			{
				"expect",{"&difficulty&",">=","3"}, --10h&25h
				"alert","countdowncd",
			},
			{
				"alert","bladecd",
				"alert",{"shardcd",time = 2},
			},
			{
				"scheduletimer",{"cd",10},
			},
		},
		windows = {
			proxwindow = true,
			proxrange = 15,
		},
		timers = {
			countdown = {
				{
					"alert","countdownwarn",
				},
			},
		},
		alerts = {
			bladecd = {
				varname = format(L.alert["%s Cooldown"],SN[99342]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[99342]),
				time = 30,
				flashtime = 5,
				color1 = "BLUE",
				icon = ST[99352],
				sound = "ALERT5",
			},
			decimationbladewarn = {
				varname = format(L.alert["%s Warning"],SN[99352]),
				type = "dropdown",
				text = format(L.alert["%s Warning"],SN[99352]),
				time = 3,
				flashtime = 3,
				color1 = "PURPLE",
				icon = ST[99352],
				sound = "ALERT2",
			},
			decimationbladedur = {
				varname = format(L.alert["%s Duration"],SN[99352]),
				type = "dropdown",
				text = format(L.alert["%s Duration"],SN[99352]),
				time = 15,
				flashtime = 5,
				color1 = "PURPLE",
				icon = ST[99352],
			},
			infernobladewarn = {
				varname = format(L.alert["%s Warning"],SN[99350]),
				type = "dropdown",
				text = format(L.alert["%s Warning"],SN[99350]),
				time = 3,
				flashtime = 3,
				color1 = "YELLOW",
				icon = ST[99350],
				sound = "ALERT2",
			},
			infernobladedur = {
				varname = format(L.alert["%s Duration"],SN[99350]),
				type = "dropdown",
				text = format(L.alert["%s Duration"],SN[99350]),
				time = 15,
				flashtime = 5,
				color1 = "YELLOW",
				icon = ST[99350],
			},
			shardwarn = {
				varname = format(L.alert["%s Warning"],SN[99259]),
				type = "simple",
				text = format(L.alert["%s Warning"],SN[99259]),
				time = 3,
				flashtime = 3,
				color1 = "PURPLE",
				icon = ST[99259],
				sound = "ALERT3",
			},
			shardcd = {
				varname = format(L.alert["%s Cooldown"],SN[99259]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[99259]),
				time = 33,
				time2 = 5,
				flashtime = 5,
				color1 = "PURPLE",
				icon = ST[99259],
				sound = "ALERT3",
			},
			-- heroic
			countdowncd = {
				varname = format(L.alert["%s Cooldown"],SN[99516]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[99516]),
				time = 46,
				flashtime = 10,
				color1 = "ORANGE",
				icon = ST[99516],
				sound = "ALERT4",
			},
			countdownwarn = {
				varname = format(L.alert["%s Warning"],SN[99516]),
				type = "simple",
				text = format(L.alert["%s on %s"],SN[99516],"&list|countdownunits&"),
				time = 3,
				flashtime = 3,
				color1 = "ORANGE",
				icon = ST[99516],
				sound = "ALERT5",
			},
			countdownself = {
				varname = format(L.alert["%s Warning"],SN[99516]),
				type = "centerpopup",
				text = format(L.alert["%s on %s"],SN[99516],L.alert["YOU"]),
				time = 8,
				flashtime = 8,
				color1 = "ORANGE",
				icon = ST[99516],
				sound = "ALERT1",
			},
		},
		announces = {
			countdownsay = {
				varname = format(L.alert["%s on self"],SN[99516]),
				type = "SAY",
				msg = format(L.alert["%s on Me"],SN[99516]),
			},
		},
		raidicons = {
			countdownicon = {
				varname = SN[99516],
				type = "MULTIFRIENDLY",
				persist = 8,
				reset = 2,
				unit = "#5#",
				icon = 1,
				total = 2,
			},
		},
		arrows = {
			--countdownarrow = {},
		},
		events = {
			-- Decimation Blade
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellname = 99352,
				execute = {
					{
						"quash","bladecd",
						"alert","bladecd",
						"alert","decimationbladewarn",
						"schedulealert",{"decimationbladedur",1.5},
					},
				},
			},
			-- Inferno Blade
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellname = 99350,
				execute = {
					{
						"quash","bladecd",
						"alert","bladecd",
						"alert","infernobladewarn",
						"schedulealert",{"infernobladedur",1.5},
					},
				},
			},
			-- Shards of Torment
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellname = 99259,
				execute = {
					{
						"quash","shardcd",
						"alert","shardcd",
						"alert","shardwarn",
					},
				},
			},
			-- Countdown heroic
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellname = 99516,
				execute = {
					{
						"insert",{"countdownunits","#5#"},
						"canceltimer","countdown",
						"scheduletimer",{"countdown",0.2},
						"raidicon","countdownicon",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"announce","countdownsay",
						"alert","countdownself",
					},
				},
			},
			-- Countdown removed
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellname = 99516,
				execute = {
					{
						"removeraidicon","#5#",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"quash","countdownself",
					},
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end


------------------------
-- Beth'tilac
------------------------
do
	local data = {
		version = 3,
		key = "Beth'tilac",
		zone = L.zone["Firelands"],
		category = L.zone["Firelands"],
		name = L.npc_firelands["Beth'tilac"],
		triggers = {
			scan = {
				52498, -- Beth'tilac
			},
		},
		onactivate = {
			tracing = {52498,powers={true}}, -- Beth'tilac
			tracerstart = true,
			combatstop = true,
			defeat = 52498,
		},
		userdata = {
			devastationcount = 0,
			devastationwarned = "no",
			kisstext = "",
			fixatetext = "",
			phase = 0,
			spinnerscd = {11,15, loop = false, type = "series"},
			spiderlingscd = {12,30, loop = false, type = "series"},
			dronescd = {45,60, loop = false, type = "series"},
		},
		onstart = {
			{
				"scheduletimer",{"energy",15},
				"set",{phase = 1},
				"batchalert",{"spinnerscd","dronescd","spiderlingscd"},
				"scheduletimer",{"dronescd",45},
			},
		},
		windows = {
		},
		timers = {
			energy = {
				{
					"expect",{"&getup|boss1&","<",13},
					"expect",{"<devastationwarned>","==","no"},
					"alert","devastationsoon",
					"set",{devastationwarned = "yes"},
				},
				{
					"scheduletimer",{"energy",1},
				},
			},
			dronescd = {
				{
					"alert","dronescd",
					"scheduletimer",{"dronescd",60},
				},
			},
		},
		alerts = {
			phasewarn = {
				varname = format(L.alert["Phase Warning"]),
				type = "simple",
				text = format(L.alert["Phase %s Warning"],"<phase>"),
				time = 3,
				flashtime = 3,
				color1 = "PURPLE",
				icon = ST[99259],
				sound = "ALERT1",
			},
			devastationwarn = {
				varname = format(L.alert["%s Casting"],SN[99048]),
				type = "centerpopup",
				text = format(L.alert["%s Casting"],SN[99048]),
				time = 8,
				flashtime = 8,
				color1 = "RED",
				icon = ST[99048],
				sound = "ALERT12",
			},
			devastationsoon = {
				varname = format(L.alert["%s Soon"],SN[99048]),
				type = "simple",
				text = format(L.alert["%s Soon"],SN[99048]),
				time = 3,
				flashtime = 3,
				color1 = "RED",
				icon = ST[99048],
				sound = "ALERT2",
			},
			kisswarn = {
				varname = format(L.alert["%s Warning"],SN[99506]),
				type = "dropdown",
				text = "<kisstext>",
				time = 20,
				flashtime = 5,
				color1 = "GREEN",
				icon = ST[99506],
				sound = "ALERT3",
			},
			spinnerscd = {
				varname = format(L.npc_firelands["Cinderweb Spinner"]),
				type = "simple",
				text = format(L.npc_firelands["Cinderweb Spinner"]),
				time = "<spinnerscd>",
				flashtime = 5,
				color1 = "BLUE",
				sound = "ALERT4",
			},
			spiderlingscd = {
				varname = format(L.npc_firelands["Cinderweb Spiderling"]),
				type = "simple",
				text = format(L.npc_firelands["Cinderweb Spiderling"]),
				time = "<spiderlingscd>",
				flashtime = 5,
				color1 = "TEAL",
				sound = "ALERT5",
			},
			dronescd = {
				varname = format(L.npc_firelands["Cinderweb Drone"]),
				type = "simple",
				text = format(L.npc_firelands["Cinderweb Drone"]),
				time = "<dronescd>",
				flashtime = 5,
				color1 = "YELLOW",
				sound = "ALERT6",
			},
			fixatewarn = {
				varname = format(L.alert["%s Warning"],SN[99559]),
				type = "simple",
				text = "<fixatetext>",
				time = 3,
				flashtime = 3,
				color1 = "BROWN",
				icon = ST[99559],
				sound = "ALERT7",
			},
			fixateself = {
				varname = format(L.alert["%s on self"],SN[99559]),
				type = "simple",
				text = format(L.alert["%s on %s"],SN[99559],L.alert["YOU"]),
				time = 3,
				flashtime = 3,
				color1 = "BROWN",
				icon = ST[99559],
				sound = "ALERT7",
				flashscreen = true,
			},
		},
		announces = {
			fixatesay = {
				varname = format(L.alert["%s on self"],SN[99559]),
				type = "SAY",
				msg = format(L.alert["%s on Me"],SN[99559]).."!",
			},
		},
		raidicons = {
			fixateicon = {
				varname = SN[99559],
				type = "FRIENDLY",
				persist = 10, --???
				reset = 9,
				unit = "#5#",
				icon = 1,
			},
		},
		events = {
			-- Stage 1
			-- Smoldering Devastation
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellname = 99048,
				execute = {
					{
						"canceltimer","energy",
						"alert","devastationwarn",
						"set",{devastationcount = "INCR|1"},
						"set",{devastationwarned = "no"},
						"scheduletimer",{"energy",15},
						"alert","spinnerscd",
					},
					{
						"expect",{"<devastationcount>","==","3"}, --perhaps better yell?
						"canceltimer","energy",
						"canceltimer","dronescd",
						"quashall",true,
						"set",{phase = 2},
						"alert","phasewarn",
					},
				},
			},
			-- Fixate (heroic)
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellname = 99559,
				execute = {
					{
						"raidicon","fixateicon",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"set",{fixatetext = format(L["%s on %s"],SN[99559],"#5")},
						"alert","fixatewarn",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","fixateself",
						"announce","fixatesay",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellname = 99559,
				execute = {
					{
						"removeraidicon","#5#",
					},
				},
			},
			-- Stage 2
			-- The Widow's Kiss
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellname = 99506,
				execute = {
					{
						"set",{kisstext = format(L["%s on %s"],SN[99506],"#5")},
						"alert","kisswarn",
					},
				},
			},
			-- Emotes
			{
				type = "event",
				event = "EMOTE",
				execute = {
					-- Spiderlings
					{
						"expect",{"#1#","find",L.chat_firelands["^Spiderlings have been roused from their nest"]},
						"alert","spiderlingscd",
					},
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end


------------------------
-- Lord Rhyolith
------------------------
do
	local data = {
		version = 1,
		key = "Rhyolith",
		zone = L.zone["Firelands"],
		category = L.zone["Firelands"],
		name = L.npc_firelands["Lord Rhyolith"],
		triggers = {
			scan = {
				52558, -- Lord Rhyolith
			},
		},
		onactivate = {
			tracing = {
				52558, -- Lord Rhyolith
				52577, -- Left foot
				53087, -- Right foot
			},
			tracerstart = true,
			combatstop = true,
			defeat = 52558,
		},
		userdata = {
			stompcd = {10,30, loop = false, type = "series"},
			fragmentcd = {22.5,45, loop = true, type = "series"},
			sparkcd = {45,69, loop = false, type = "series"},
			phase = "0",
		},
		onstart = {
			{
				"alert",{"fragmentcd",time = 2},
				"alert","sparkcd",
				"alert","stompcd",
			},
		},
		--windows = {},
		timers = {
		},
		alerts = {
			phasewarn = {
				varname = format(L.alert["Phase Warning"]),
				type = "simple",
				text = format(L.alert["Phase %s Warning"],"<phase>"),
				time = 3,
				flashtime = 3,
				color1 = "PURPLE",
				sound = "ALERT1",
			},
			stompcd = {
				varname = format(L.alert["%s Cooldown"],SN[100411]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[100411]),
				time = "<stompcd>",
				flashtime = 5,
				color1 = "ORANGE",
				icon = ST[100411],
			},
			stompwarn = {
				varname = format(L.alert["%s Casting"],SN[100411]),
				type = "centerpopup",
				text = format(L.alert["%s Casting"],SN[100411]),
				time = 3,
				flashtime = 3,
				color1 = "ORANGE",
				icon = ST[100411],
				sound = "ALERT2",
			},
			fragmentcd = {
				varname = format(L.alert["%s Cooldown"],SN[98136]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[98136]),
				time = "<fragmentcd>",
				time2 = 21,
				flashtime = 5,
				color1 = "BROWN",
				icon = ST[98136],
				sound = "ALERT3",
			},
			sparkcd = {
				varname = format(L.alert["%s Cooldown"],SN[98552]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[98552]),
				time = "<sparkcd>",
				flashtime = 5,
				color1 = "YELLOW",
				icon = ST[99262],
				sound = "ALERT3",
			},
		},
		--announces = {},
		--raidicons = {},
		events = {
			-- Stomp
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellname = 100411,
				execute = {
					{
						"quash","stompcd",
						"alert","stompcd",
						"alert","stompwarn",
					},
				},
			},
			-- Fragment
			{
				type = "combatevent",
				eventtype = "SPELL_SUMMON",
				spellname = 98136,
				execute = {
					{
						"quash","fragmentcd",
						"alert","fragmentcd",
					},
				},
			},
			-- Spark
			{
				type = "combatevent",
				eventtype = "SPELL_SUMMON",
				spellname = 98552,
				execute = {
					{
						"quash","sparkcd",
						"alert","sparkcd",
					},
				},
			},
			-- Emotes
			{
				type = "event",
				event = "EMOTE",
				execute = {
					{
						"expect",{"#1#","find",L.chat_firelands["stumbles as his armor is shattered"]},
						"batchquash",{"sparkcd","fragmentcd"},
						"set",{phase = "2"},
						"alert","phasewarn",
					},
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end


------------------------
-- Majordomo Fandral Staghelm
------------------------
do
	local data = {
		version = 3,
		key = "Staghelm",
		zone = L.zone["Firelands"],
		category = L.zone["Firelands"],
		name = L.npc_firelands["Majordomo Fandral Staghelm"],
		triggers = {
			scan = {
				52571, -- Majordomo Fandral Staghelm
			},
		},
		onactivate = {
			tracing = {52571,powers={true}}, -- Majordomo Fandral Staghelm
			tracerstart = true,
			combatstop = true,
			defeat = 52571,
		},
		userdata = {
			seedtime = 0,
			abilitycd = {19,14,8.5,7.3, loop = false, type = "series"}, -- not sure we need this
		},
		onstart = {
		},
		windows = {
			proxwindow = true,
			proxrange = 12,
		},
		--timers = {},
		alerts = {
			catwarn = {
				varname = format(L.alert["%s Warning"],SN[98374]),
				type = "simple",
				text = format(L.alert["%s Warning"],SN[98374]),
				time = 3,
				flashtime = 3,
				color1 = "YELLOW",
				icon = ST[98374],
				sound = "ALERT1",
			},
			scorpionwarn = {
				varname = format(L.alert["%s Warning"],SN[98379]),
				type = "simple",
				text = format(L.alert["%s Warning"],SN[98379]),
				time = 3,
				flashtime = 3,
				color1 = "BROWN",
				icon = ST[98379],
				sound = "ALERT2",
			},
			orbswarn = {
				varname = format(L.alert["%s Warning"],SN[98451]),
				type = "centerpopup",
				text = format(L.alert["%s Warning"],SN[98451]),
				time = 4,
				flashtime = 4,
				color1 = "ORANGE",
				icon = ST[98451],
				sound = "ALERT3",
			},
			orbsdur = {
				varname = format(L.alert["%s Duration"],SN[98451]),
				type = "dropdown",
				text = format(L.alert["%s Duration"],SN[98451]),
				time = 60,
				flashtime = 10,
				color1 = "ORANGE",
				icon = ST[98451],
			},
			seedswarn = {
				varname = format(L.alert["%s Warning"],SN[98450]),
				type = "simple",
				text = format(L.alert["%s Warning"],SN[98450]),
				time = 4,
				flashtime = 4,
				color1 = "PURPLE",
				icon = ST[98450],
				sound = "ALERT4",
			},
			seedsself = {
				varname = format(L.alert["%s Warning"],SN[98450]),
				type = "dropdown",
				text = format(L.alert["%s on %s"],SN[98450],L.alert["YOU"]),
				time = "<seedtime>",
				flashtime = 4,
				color1 = "PURPLE",
				icon = ST[98450],
				sound = "ALERT12",
			},
		},
		--announces = {},
		--raidicons = {},
		events = {
			--Orbs
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellname = 98451,
				execute = {
					{
						"alert","orbswarn",
						"schedulealert",{"orbsdur",4}
					},
				},
			},
			-- Seeds
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellname = 98450,
				execute = {
					{
						"alert","seedswarn",
					},
				},
			},
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellname = 98450,
				execute = {
					{
						"expect",{"#4#","==","&playerguid&"},
						"set",{seedtime = "&playerdebuffdur|"..SN[98450].."&"},
						"alert","seedsself",
					},
				},
			},
			-- Yells (use buffs!)
			{
				type = "event",
				event = "YELL",
				execute = {
					-- Cat Form
					{
						"expect",{"#1#","find",L.chat_firelands["^Behold the rage of the Firelands"]},
						"alert","catwarn",
					},
					-- Scorpion Form
					{
						"expect",{"#1#","find",L.chat_firelands["^The master's power takes on many forms"]},
						"alert","scorpionwarn",
					},
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end


------------------------
-- Shannox
------------------------
do
	local data = {
		version = 2,
		key = "Shannox",
		zone = L.zone["Firelands"],
		category = L.zone["Firelands"],
		name = L.npc_firelands["Shannox"],
		triggers = {
			scan = {
				53691, -- Shannox
			},
			yell = L.chat_firelands["Aha! The interlopers"],
		},
		onactivate = {
			tracing = {
				53691, -- Shannox
				53694, -- Riplimb
				53695, -- Rageface
			},
			tracerstart = true,
			combatstop = true,
			defeat = 53691,
		},
		userdata = {
			jaggedtext = "",
			traptext = "",
			traptype = "",
			immotrapcd = {16,10, loop = true, type = "series"},
			crystaltrapcd = {9,25, loop = false, type = "series"},
			spearcd = {18,41, loop = false, type = "series"},
		},
		onstart = {
			{
				"alert","spearcd",
				"alert","immotrapcd",
				"alert","crystaltrapcd",
			},
		},
		windows = {
		},
		arrows = {
			crystaltraparrow = {
				varname = format(L.npc_firelands["Crystal Prison"]),
				unit = "#5#",
				persist = 30,
				action = "TOWARD",
				msg = L.alert["Free him!"],
				spell = SN[98159],
				sound = "ALERT5",
			},
		},
		timers = {
		},
		alerts = {
			spearcd = {
				varname = format(L.alert["%s Cooldown"],SN[100002]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[100002]),
				time = "<spearcd>",
				flashtime = 5,
				color1 = "GREEN",
				icon = ST[100002],
			},
			spearwarn = {
				varname = format(L.alert["%s Warning"],SN[100002]),
				type = "simple",
				text = format(L.alert["%s Warning"],SN[100002]),
				time = 3,
				flashtime = 3,
				color1 = "GREEN",
				sound = "ALERT1",
				icon = ST[100002],
			},
			immotrapcd = {
				varname = format(L.alert["%s Cooldown"],SN[99839]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[99839]),
				time = "<immotrapcd>",
				flashtime = 5,
				color1 = "ORANGE",
				icon = ST[99839],
			},
			crystaltrapcd = {
				varname = format(L.alert["%s Cooldown"],SN[99836]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[99836]),
				time = "<crystaltrapcd>",
				flashtime = 5,
				color1 = "BLUE",
				icon = ST[99836],
			},
			crystaltrapwarn = {
				varname = format(L.alert["%s Warning"],SN[99836]),
				type = "simple",
				text = "<traptext>",
				time = 5,
				flashtime = 5,
				color1 = "BLUE",
				sound = "ALERT3",
				icon = ST[99836],
			},
			crystaltrapself = {
				varname = format(L.alert["%s Warning on self"],SN[99836]),
				type = "simple",
				text = format(L.alert["%s on %s"],SN[99836],L.alert["YOU"]),
				time = 5,
				flashtime = 5,
				color1 = "BLUE",
				sound = "ALERT3",
				icon = ST[99836],
			},
			trapwarn = {
				varname = format(L.alert["Trap Warning"]),
				type = "simple",
				text = format(L.alert["%s Trap on %s"],"<traptype>",L.alert["YOU"]),
				text2 = format(L.alert["%s Trap"],"<traptype>"),
				time = 3,
				flashtime = 3,
				color1 = "RED",
				sound = "ALERT12",
				icon = ST[99836],
			},
			riplimbcd = {
				varname = format(L.alert["%s Resurrection"],L.npc_firelands["Riplimb"]),
				type = "dropdown",
				text = format(L.alert["%s Resurrection"],L.npc_firelands["Riplimb"]),
				time = 30,
				flashtime = 5,
				color1 = "PURPLE",
				icon = ST[38601],
				sound = "ALERT6",
			},
		},
		announces = {
			immotrapsay = {
				varname = format(L.alert["%s on self"],SN[99839]),
				type = "SAY",
				msg = format(L.alert["%s on Me"],SN[99839]).."!",
			},
			crystaltrapsay = {
				varname = format(L.alert["%s on self"],SN[99836]),
				type = "SAY",
				msg = format(L.alert["%s on Me"],SN[99836]).."!",
			},
		},
		raidicons = {
			crystaltrapicon = {
				varname = SN[99836],
				type = "FRIENDLY",
				persist = 30,
				reset = 29,
				unit = "#5#",
				icon = 2,
			},
			rageicon = {
				varname = SN[100415],
				type = "FRIENDLY",
				persist = 15,
				reset = 2,
				unit = "#5#",
				icon = 1,
			},
		},
		events = {
			-- Rage
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellname = 100415,
				execute = {
					{
						"raidicon","rageicon",
					},
				},
			},
			-- Hurl Spear
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellname = 100002,
				execute = {
					{
						"quash","spearcd",
						"alert","spearwarn",
						"alert","spearcd",
					},
				},
			},
			-- Riplimb dies
			{
				type = "combatevent",
				eventtype = "UNIT_DIED",
				execute = {
					{
						"expect",{"&npcid|#4#&","==","53694"},
						"quash","spearcd",
						"alert","riplimbcd",
					},
				},
			},
			-- Immolation Trap (possibly target function, could be spammy)
			{
				type = "combatevent",
				eventtype = "SPELL_SUMMON",
				spellname = 99839,
				srcnpcid = 53691, -- Shannox
				execute = {
					{
						"quash","immotrapcd",
						"alert","immotrapcd",
						"set",{traptype = L.npc_firelands["Crystal Prison Trap"]},
					},
					{
						"target",{
							source = "#1#",
							wait = 0.2,
							announce = "immotrapsay",
							alerts = {
								self = "trapwarn",
								unknown = {"trapwarn",text = 2},
							},
						},
					},
				},
			},
			-- Crystal Prison Trap (possibly target function, could be spammy)
			{
				type = "combatevent",
				eventtype = "SPELL_SUMMON",
				spellname = 99836,
				srcnpcid = 53691, -- Shannox
				execute = {
					{
						"quash","crystaltrapcd",
						"alert","crystaltrapcd",
						"set",{traptype = L.npc_firelands["Immolation Trap"]},
					},
					{
						"target",{
							source = "#1#",
							wait = 0.2,
							announce = "crystaltrapsay",
							alerts = {
								self = "trapwarn",
								unknown = {"trapwarn",text = 2},
							},
						},
					},
				},
			},
			-- Crystal Prison Trap Effect
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellname = 99837,
				dstisplayertype = true,
				execute = {
					{
						"raidicon","crystaltrapicon",
						"arrow","crystaltraparrow",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"set",{traptext = format(L.alert["%s on %s"],SN[99836],"#5#")},
						"alert","crystaltrapwarn",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","crystaltrapself",
					},
				},
			},
			-- Crystal Prison Trap Effect removed
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellname = 99837,
				dstisplayertype = true,
				execute = {
					{
						"removeraidicon","#5#",
						"removearrow","#5#",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"quash","crystaltrapwarn",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"quash","crystaltrapself",
					},
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end


------------------------
-- Ragnaros
------------------------
do
	local data = {
		version = 2,
		key = "Ragnaros",
		zone = L.zone["Firelands"],
		category = L.zone["Firelands"],
		name = L.npc_firelands["Ragnaros"],
		triggers = {
			scan = {
				52409 , -- Ragnaros
			},
		},
		onactivate = {
			tracing = {52409 }, -- Ragnaros
			tracerstart = true,
			combatstop = true,
			defeat = 52409,
		},
		userdata = {
			phase = 0,
			trapcd = {15,25, loop = false, type = "series"},
			smashcd = {30,40, loop = false, type = "series"},
			flamescd = {40,60, loop = false, type = "series"},
			seedcd = {10,60, loop = false, type = "series"},
		},
		onstart = {
			{
				"set",{
					phase = 1,
				},
				"alert","smashcd",
				"alert","trapcd",
			},
		},
		windows = {
			proxwindows = true,
			proxrange = 6,
		},
		timers = {
			phasechange = {
				{
					"expect",{"<phase>","==",L.alert["Intermission 1"]},
					"set",{
						smashcd = {30,40,50,40, loop = false, type = "series"},
						phase = 2,
					},
					"alert","smashcd",
					"alert","flamescd",
					"alert","seedcd",
					"scheduletimer",{"seeds",10},
				},
				{
					"expect",{"<phase>","==",L.alert["Intermission 2"]},
					"set",{
						smashcd = {10,40, loop = false, type = "series"},
						flamescd = {30,60, loop = false, type = "series"},
						phase = 3,
					},
					"alert","smashcd",
					"alert","flamescd",
				},
			},
			seeds = {
				{
					"alert","seedwarn",
					"alert","seedcd",
					"scheduletimer",{"seeds",60},
				},
			},
		},
		alerts = {
			phasewarn = {
				varname = format(L.alert["Phase Warning"]),
				type = "simple",
				text = format(L.alert["Phase %s Warning"],"<phase>"),
				time = 3,
				flashtime = 3,
				color1 = "PURPLE",
				sound = "ALERT11",
			},
			phasedur = {
				varname = format(L.alert["Phase Duration"]),
				type = "dropdown",
				text = format(L.alert["Phase %s Duration"],"<phase>"),
				time = 45,
				flashtime = 5,
				color1 = "PURPLE",
			},
			trapwarn = {
				varname = format(L.alert["%s Casting"],SN[101233]),
				type = "simple",
				text = format("%s: &upvalue&!",SN[101233]),
				text2 = format(L.alert["%s Casting"],SN[101233]),
				time = 3,
				color1 = "ORANGE",
				sound = "ALERT1",
				icon = ST[101233],
			},
			trapself = {
				varname = format(L.alert["%s on self"],SN[101233]),
				type = "simple",
				text = format("%s: %s!",SN[101233],L.alert["YOU"]),
				time = 3,
				color1 = "ORANGE",
				sound = "ALERT12",
				icon = ST[101233],
				flashscreen = true,
			},
			trapcd = {
				varname = format(L.alert["%s Cooldown"],SN[101233]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[101233]),
				time = "<trapcd>",
				flashtime = 5,
				color1 = "ORANGE",
				icon = ST[101233],
			},
			smashwarn = {
				varname = format(L.alert["%s Warning"],SN[100258]),
				type = "centerpopup",
				text = format(L.alert["%s Warning"],SN[100258]),
				time = 2.5,
				flashtime = 2.5,
				color1 = "BROWN",
				icon = ST[100258],
				sound = "ALERT2",
			},
			smashcd = {
				varname = format(L.alert["%s Cooldown"],SN[100258]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[100258]),
				time = "<smashcd>",
				flashtime = 5,
				color1 = "BROWN",
				icon = ST[100258],
			},
			flameswarn = {
				varname = format(L.alert["%s Warning"],SN[100172]),
				type = "centerpopup",
				text = format(L.alert["%s Warning"],SN[100172]),
				time = 3,
				flashtime = 5,
				color1 = "YELLOW",
				icon = ST[100172],
			},
			flamescd = {
				varname = format(L.alert["%s Cooldown"],SN[100172]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[100172]),
				time = "<flamescd>",
				flashtime = 5,
				color1 = "YELLOW",
				icon = ST[100172],
			},
			seedwarn = {
				varname = format(L.alert["%s Warning"],SN[98333]),
				type = "centerpopup",
				text = format(L.alert["%s Warning"],SN[98333]),
				time = 10,
				flashtime = 5,
				color1 = "ORANGE",
				icon = ST[98333],
			},
			seedcd = {
				varname = format(L.alert["%s Cooldown"],SN[98333]),
				type = "dropdown",
				text = format(L.alert["%s Cooldown"],SN[98333]),
				time = "<seedcd>",
				flashtime = 5,
				color1 = "ORANGE",
				icon = ST[98333],
			},
			heatwarn = {
				varname = format(L.alert["%s Warning"],SN[100981]),
				type = "simple",
				text3 = format(L.alert["%s Warning"],SN[100981]),
				time = 3,
				color1 = "RED",
				sound = "ALERT1",
				icon = ST[100981],
			},
			heatself = {
				varname = format(L.alert["%s on self"],SN[100981]),
				type = "simple",
				text = format("%s: %s!",SN[100981],L.alert["YOU"]),
				time = 3,
				color1 = "RED",
				sound = "ALERT12",
				icon = ST[100981],
				flashscreen = true,
			},
			-- meteor
			meteorwarn = {
				varname = format(L.alert["%s Warning"],SN[99268]),
				type = "simple",
				text3 = format(L.alert["%s Warning"],SN[99268]),
				time = 3,
				color1 = "ORANGE",
				sound = "ALERT1",
				icon = ST[99268],
			},
		},
		announces = {
			trapsay = {
				varname = format(L.alert["%s on self"],SN[98159]),
				type = "SAY",
				msg = format(L.alert["%s on Me"],SN[98159]).."!",
			},
		},
		raidicons = {
			trapmark = {
				varname = SN[98159],
				type = "FRIENDLY",
				persist = 6,
				reset = 5,
				unit = "&upvalue&",
				icon = 1,
				total = 1,
			},
			heatmark = {
				varname = SN[100981],
				type = "MULTIFRIENDLY",
				persist = 10,
				reset = 9,
				unit = "#5#",
				icon = 2,
				total = 2, --more in heroic?
			},
		},
		events = {
			-- Magma Trap
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS",
				spellname = 98159,
				execute = {
					{
						"target",{
							source = "#1#", -- Ragnaros
							wait = 0.2,
							announce = "trapsay",
							raidicon = "trapmark",
							alerts = {
								self = "trapself",
								other = "trapwarn",
								unknown = {"trapwarn",text = 2},
							},
						},
						"alert","trapcd",
					},
				},
			},
			-- Sulfuras Smash
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellname = 100258,
				execute = {
					{
						"quash","smashcd",
						"alert","smashwarn",
						"alert","smashcd",
					},
				},
			},
			-- Splitting Blow == Intermission
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellname = 100885,
				execute = {
					{
						"batchquash",{"smashcd","trapcd","flamescd"},
					},
					{
						"invoke",{
							{
								"expect",{"<phase>","==","1"},
								"set",{phase = L.alert["Intermission 1"]},
							},
							{
								"expect",{"<phase>","==","2"},
								"set",{phase = L.alert["Intermission 2"]},
							},
						},
						"alert","phasewarn",
						"schedulealert",{"phasedur",10},
					},
				},
			},
			-- Engulfing Flames
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_START",
				spellname = 100172,
				execute = {
					{
						"quash","flamescd",
						"alert","flamescd",
						"alert","flameswarn",
					},
				},
			},
			-- Blazing Heat
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_APPLIED",
				spellname = 100981,
				execute = {
					{
						"raidicon","heatmark",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"alert","heatwarn",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"alert","heatself",
					},
				},
			},
			-- Blazing Heat removed
			{
				type = "combatevent",
				eventtype = "SPELL_AURA_REMOVED",
				spellname = 100981,
				execute = {
					{
						"removeraidicon","#5#",
					},
					{
						"expect",{"#4#","~=","&playerguid&"},
						"quash","heatwarn",
					},
					{
						"expect",{"#4#","==","&playerguid&"},
						"quash","heatself",
					},
				},
			},
			-- Meteor Summon
			{
				type = "combatevent",
				eventtype = "SPELL_CAST_SUCCESS", --???
				spellname = 99268,
				execute = {
					{
						"alert","meteorwarn", --cd?
					},
				},
			},
			-- Meteor fixate

			-- Yells
			{
				type = "event",
				event = "YELL",
				execute = {
					--Intermission ends
					{
						"expect",{"#1#","find",L.chat_firelands["^Enough! I will finish this"]},
						"scheduletimer",{"phasechange",0.1},
					},
					{
						"expect",{"#1#","find",L.chat_firelands["^Fall to your knees"]},
						"scheduletimer",{"phasechange",0.1},
					},
					{
						"expect",{"#1#","find",L.chat_firelands["^Sulfuras will be your end"]},
						"scheduletimer",{"phasechange",0.1},
					},
				},
			},
		},
	}

	DXE:RegisterEncounter(data)
end
